section(anchor="PLCServer")
  name PLCServer bridge

  t
    | The PLCServer is a component that bridges Siemens S7 protocol to DIM.

  t
    | PLC registers are mapped in one or several DIM Parameters Service as
    | described in #[xref(target="dim-xml-extension-01") DIM XML Extension].

  t
    | The PLCServer component exposes a #[tt= "<serverName>/State"] DIM State
    | service, displaying errors from the PLCs (network error ...),
    | this service has only two states (OK and ERROR).

  t
    | #[strong Note:] the DIM Parameters #[bcp14 MAY] not directly reflect
    | modifications, by having different #[em srcDBNumber/srcAddress] and
    | #[em destDBNumber/destAddress] the PLC #[bcp14 MAY] reflect a write
    | only once an action is finished, making this service asynchronous.

  section
    name Configuration

    t
      | The #[em PLCServer] component #[bcp14 MAY] be configured:
    figure
      name PLCServer configuration
      sourcecode(type='rnc' src='ntof-software-architecture/files/PLCServer_Configuration.rnc')

    t
      | The following types are supported:
    table(align="center")
      name PLCServer data types
      thead
        tr #[th Type] #[th DIM Data Type] #[th PLC Data Type]
      tbody
        tr #[td BYTE] #[td 1 (int32)] #[td uint8_t]
        tr #[td WORD] #[td 1 (int32)] #[td uint16_t]
        tr #[td INT] #[td 1 (int32)] #[td int16_t]
        tr #[td DWORD] #[td 1 (int32)] #[td uint32_t]
        tr #[td DINT] #[td 1 (int32)] #[td int32_t]
        tr #[td REAL] #[td 2 (double)] #[td float]
        tr #[td ENUM] #[td 5 (enum)] #[td int16_t]

    t
      | The #[em destDBNumber] and #[em destAddress] attributes are optional,
      | the DIM Parameter value being read-only when not set.

  section(anchor="FilterStation")
    name Filter Station

    t
      | The #[em FilterStation] is a #[xref(target="PLCServer") PLCServer service]
      | that has the following properties:
    table(align="center")
      name FilterStation properties
      thead
        tr #[th Property] #[th Index] #[th Type]
      tbody
        tr #[td Air pressure] #[td 1] #[td REAL]
        tr #[td Filter 1] #[td 2] #[td ENUM]
        tr #[td Filter 2] #[td 3] #[td ENUM]
        tr #[td Filter 3] #[td 4] #[td ENUM]
        tr #[td Filter 4] #[td 5] #[td ENUM]
        tr #[td Filter 5] #[td 6] #[td ENUM]
        tr #[td Filter 6] #[td 7] #[td ENUM]
        tr #[td Filter 7] #[td 8] #[td ENUM]
        tr #[td Filter 8] #[td 9] #[td ENUM]

    t
      | Filters properties are #[em ENUM] with the following values:
    figure
      name Filter position enum
      sourcecode(type='XML' src='ntof-software-architecture/files/FilterStation_enum.xml')

    t
      | The filters are moved asynchronously, meaning a filter is modified
      | from DIM, it's value is likely to first be changed to "MOVING" and
      | then to the requested state.

    t
      | The #[em _INTERLOCKED] suffix indicates that an incompatible (size-wise)
      | filter is being used in the station and that this filter can't
      | be controled anymore.

    t
      | Whenever #[xref(target='FilterStation') filter-station] is configured
      | on #[xref(target='EACS') EACS],
      | filters that are not configured in database #[bcp14 MUST] always be
      | moved out of the beam.

    t
      | Indexes from database #[bcp14 MUST] be shifted by one (databaseIndex 1 -&gt; first filter).
